Subject: Re: bug#64055: Implementation of modifying VC change comments for Git

From: Sean Whitton <[email-masked]>
Date: Sat, 26 Oct 2024 11:12:08 +0800

Hello,

On Sat 26 Oct 2024 at 04:58am +03, Dmitry Gutov wrote:

> Hi Sean,
>
> On 20/10/2024 08:19, Sean Whitton wrote:
>> +Many Git commands can change your copy of published change history
>> +without warning.  If VC commands detect that this could happen, they
>> +will stop.  You can customize this variable to permit rewriting history
>> +even though Emacs thinks it is dangerous.
>> +
>> +So far, this applies only to the 'log-view-modify-change-comment'
>> +command.
>
> Coming back to this text - do you think the first and the last sentences might
> mismatch? First we talk about "many Git commands", next sentence "VC
> commands", plural. And in the end we say this only applies to one.
>
> Maybe we can rephrase it like this:
>
>  Some VCS commands can change your copy of published change history
>  without warning.  In VC we try to detect before that happens, and stop.
>  You can customize this variable to permit rewriting history
>  even though Emacs thinks it is dangerous.
>
>  So far, this applies only to using 'e' from Log View mode for Git.

Whether or not there is a strict mismatch, I like your new text more.
Please install it.

> BTW, there is another existing command which can end up changing
> published history: 'vc-git-log-edit-toggle-amend'. I wonder what will
> be our plan for it. Maybe we just add the same check there.

Thanks for reminding me about this.  Yes, I think it should be fine to
just add (vc-git--assert-allowed-rewrite "HEAD") or similar.  Would you
like to do it along with your NEWS change?  I guess, then, dropping the
"So far ..." sentence.

-- 
Sean Whitton